%global cpan_version 0.997015

Name:           perl-App-cpm
Version:        0.997.015
Release:    1%{?dist}
Summary:        Fast CPAN module installer
License:        GPL-1.0-or-later OR Artistic-1.0-Perl
URL:            https://metacpan.org/release/App-cpm
Source0:        https://cpan.metacpan.org/authors/id/S/SK/SKAJI/App-cpm-%{cpan_version}.tar.gz
BuildArch:      noarch
BuildRequires:  coreutils
BuildRequires:  findutils
BuildRequires:  perl-generators
BuildRequires:  perl-interpreter
BuildRequires:  perl(:VERSION) >= 5.8.1
BuildRequires:  perl(Module::Build::Tiny) >= 0.034
BuildRequires:  perl(strict)
BuildRequires:  perl(warnings)
BuildRequires:  perl(Test::More)
Requires:       gzip
Requires:       perl(Archive::Tar)
Requires:       perl(Archive::Zip) >= 1.68
Requires:       perl(Command::Runner) >= 0.100
Requires:       perl(ExtUtils::Install) >= 2.20
Requires:       perl(ExtUtils::InstallPaths) >= 0.002
Requires:       perl(File::HomeDir)
Requires:       perl(HTTP::Tinyish) >= 0.12
Requires:       perl(JSON::PP) >= 2.27300
Requires:       perl(local::lib)
Requires:       perl(Menlo::CLI::Compat) >= 1.9021
Requires:       perl(Module::CoreList)
Requires:       perl(Module::cpmfile) >= 0.001
Requires:       perl(Parallel::Pipes::App) >= 0.100
Requires:       perl(Parse::PMFile) >= 0.43
Requires:       perl(YAML::PP) >= 0.026
Suggests:       perl(Carton::Snapshot)

%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^perl\\(JSON::PP\\)$
%global __requires_exclude %__requires_exclude|^perl\\(Command::Runner\\)$
%global __requires_exclude %__requires_exclude|^perl\\(ExtUtils::Install\\)$
%global __requires_exclude %__requires_exclude|^perl\\(ExtUtils::InstallPaths\\)$
%global __requires_exclude %__requires_exclude|^perl\\(HTTP::Tinyish\\)$
%global __requires_exclude %__requires_exclude|^perl\\(Menlo::CLI::Compat\\)$
%global __requires_exclude %__requires_exclude|^perl\\(Module::cpmfile\\)$
%global __requires_exclude %__requires_exclude|^perl\\(Parallel::Pipes::App\\)$
%global __requires_exclude %__requires_exclude|^perl\\(YAML::PP\\)$

%description
cpm is a fast CPAN module installer, which uses Menlo::CLI::Compat in
parallel.

%package tests
Summary:        Tests for %{name}
Requires:       %{name} = %{version}-%{release}
Requires:       perl-Test-Harness

%description tests
Tests from %{name}. Execute them
with "%{_libexecdir}/%{name}/test".

%prep
%setup -q -n App-cpm-%{cpan_version}
for F in t/*.t; do
    perl -i -MConfig -ple 'print $Config{startperl} if $. == 1' "$F"
    chmod +x "$F"
done

%build
perl Build.PL --installdirs=vendor
./Build

%install
./Build install --destdir=%{buildroot} --create_packlist=0
find %{buildroot}%{_mandir} -type f -empty -delete
%{_fixperms} %{buildroot}/*

mkdir -p %{buildroot}/%{_libexecdir}/%{name}
cp -a t %{buildroot}/%{_libexecdir}/%{name}
cat > %{buildroot}/%{_libexecdir}/%{name}/test << 'EOF'
cd %{_libexecdir}/%{name} && exec prove -I . -j "$(getconf _NPROCESSORS_ONLN)"
EOF
chmod +x %{buildroot}/%{_libexecdir}/%{name}/test

%check
export HARNESS_OPTIONS=j$(perl -e 'if ($ARGV[0] =~ /.*-j([0-9][0-9]*).*/) {print $1} else {print 1}' -- '%{?_smp_mflags}')
./Build test

%files
%license LICENSE
%doc Changes
%{_bindir}/cpm
%dir %{perl_vendorlib}/App
%{perl_vendorlib}/App/cpm
%{perl_vendorlib}/App/cpm.pm
%{_mandir}/man1/cpm.*
%{_mandir}/man3/App::cpm.*
%{_mandir}/man3/App::cpm::*

%files tests
%{_libexecdir}/%{name}

%changelog
* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.997.015-1
- initial build
